def firewall_detector(req, target, info_cb, found_cb, not_found_cb):
    # https://github.com/OWASP/vbscan/blob/master/modules/firewall.pl
    is_found = False

    name = "vBulletin's default firewall"
    info_cb(f"Checking {name}")

    req.headers.update(
        {"User-Agent": "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.0.5) Gecko/20060719 Firefox/1.5.0.5"}
    )
    r = req.get(target)

    if r.status_code == 200:
        if "dnp_firewall" in r.text.lower() or "DnP Firewall".lower() in r.text.lower() or "dnp_fw" in r.text.lower():
            found_cb("Firewall is detected")
            is_found = True

            user_agent = [
                'Googlebot',
                'msnbot',
                'slurp',
                'fast-webcrawler',
                'Googlebot-Image',
                'teomaagent1',
                'directhit',
                'lycos',
                'ia_archiver',
                'gigabot',
                'whatuseek',
                'Teoma',
                'scooter',
                'Ask Jeeves',
                'slurp@inktomi',
                'gzip(gfe) (via translate.google.com)',
                'Mediapartners-Google',
                'crawler@alexa.com'
            ]

            for agent in user_agent:
                req.headers.update({"User-Agent": agent})
                r = req.get(target)
                if "dnp_firewall" in r.text.lower() or "DnP Firewall".lower() in r.text.lower() or \
                        "dnp_fw" in r.text.lower():
                    found_cb(f'Firewall bypassed by setting "{agent}" as default user agent')
                    return agent

    if not is_found:
        # No firewall is found
        not_found_cb(name)
        return 0

    # Firewall is found but can't find any agent to bypass
    return -1
